// window.injs = {};
// window.injs.init = function() {
// 	return '{"token":"","client_version":"610","base_uri":"http://115.182.49.247:8060/appserver","nav_bar_height":100}';
// };
// window.injs.getQuickStartupGameList = function() {
// 	// return '[{"id":1,"name":"1sdfsdf1","package":"2sdfdjsfjkdsflsdf2"},{"id":2,"name":"2sdfsdf2","package":"sdfdjsfjkdsflsdf"},{"id":3,"name":"3sdfsdf3","package":"sdfdjsfjkdsflsdf"}]';
// 	return '[]';
// };

var Entrance = {};

Entrance.init = function() {
	var _ = window.injs.init();
	if (!_) {
		return false;
	}
	_ = $.parseJSON(_);
	this.token = _.token;
	this.client_version = _.client_version;
	this.base_uri = _.base_uri;
	this.nav_bar_height = _.nav_bar_height;
	_ = window.injs.getQuickStartupGameList();
	_ = $.parseJSON(_);
	this.game_list = _;
	this.initGameList();
	this._choosed_game_ids = [0, 0];
	$("#nav_bar_backgroud").css('height', this.nav_bar_height + "px");
};

Entrance.refreshToken = function(data) {
	this.token = data;
	this.showBought();
	this.showQuickStartupGame();
};

Entrance.refreshQuickStartupGameList = function(data) {
	if (!data) {
		return false;
	}
	this.game_list = $.parseJSON(data);
	this.initGameList();
	this.showQuickStartupGame();
};

Entrance.initGameList = function() {
	this._startup_game = [];
	if (this.game_list.length < 3) {
		this._startup_game = this.game_list;
	} else if (this.game_list.length > 2) {
		var _ids = get2Random(this.game_list.length);
		this._startup_game[0] = this.game_list[_ids[0]];
		this._startup_game[1] = this.game_list[_ids[1]];
	}
	var html = "";
	for (var i = 0; i < this.game_list.length; i++) {
		game = this.game_list[i];
		html += '<li id="game_' + game.id + '" onclick="Entrance.chooseQuickStartupGame(' + game.id + ');"><p' + (countCharacters(game.name) > 10 ? 'class="part"' : '') + '>' + game.name +
			'</p></li>';
	}
	$("#game_list").html(html);
};

Entrance.exchangeQuickStartupGame = function() {
	if (0 == this._choosed_game_ids[0] || 0 == this._choosed_game_ids[1]) {
		this.hideExchangeBox();
		return;
	}
	this._startup_game = [];
	for (var i = 0; i < this.game_list.length; i++) {
		game = this.game_list[i];
		if (game.id == this._choosed_game_ids[1] || game.id == this._choosed_game_ids[0]) {
			this._startup_game.push(game);
		}
	}
	this.showQuickStartupGame();
	this.hideExchangeBox();
};

Entrance.chooseQuickStartupGame = function(id) {
	if (id == this._choosed_game_ids[1] || id == this._choosed_game_ids[0])
		return;
	$("#game_list #game_" + this._choosed_game_ids[0]).removeClass("hover");
	this._choosed_game_ids[0] = this._choosed_game_ids[1];
	this._choosed_game_ids[1] = id;
	$("#game_list #game_" + id).addClass("hover");
};

Entrance.showExchangeBox = function() {
	$("table").show();
};

Entrance.hideExchangeBox = function() {
	$("table").hide();
};

Entrance.showQuickStartupGame = function() {
	if (this._startup_game.length == 0) {
		$("#quickStartupGame").html('<div class="content-none">安装游戏后才能快速启动哦~</div>');
		return;
	}
	var html = '';
	for (var i = 0; i < this._startup_game.length; i++) {
		game = this._startup_game[i];
		this._choosed_game_ids[i] = game.id;
		$("#game_list #game_" + game.id).addClass("hover");
		html += '<div class="cnt" id="' + game.id + '">';
		html += '    <div class="top-bottom">';
		html += '        <div class="top">';
		html += '            <div class="left"><img src="http://app.moyoyo.com/appstatic/game_icon/' + game.id + '.png"></div>';
		html += '            <div class="right">';
		html += '                <p>' + game.name + '</p>';
		html += '                <p class="part" onclick="javascript:window.injs.openGame(\'' + game.package + '\')"><i><b></b></i>启动游戏</p>';
		html += '            </div>';
		html += '        </div>';
		html += '        <div class="bottom">';
		html += '            <a href="http://m.moyoyo.com/gamezone/goods/list.html?gameid=' + game.id + '&goodsid=0&sid=0&platformid=1">购买商品</a>';
		html += '        </div>';
		html += '    </div>';
		html += '</div>';

		$.ajax({
			type: "get",
			url: getUrl("order/boughtB2C"),
			jsonp: "callback",
			dataType: "jsonp",
			cache: false,
			contentType: "application/jsonp;charset=utf-8",
			data: {
				gameId: game.id,
				token: this.token,
				version: this.client_version
			}
		}).done(function(data) {
			if (data.resultMsg == true) {
				$("#quickStartupGame #" + data.gameId + " .bottom").append('<a class="btn" href="http://m.moyoyo.com/gamezone/goods/list.html?gameid=' + data.gameId +
					'&goodsid=0&sid=0&platformid=1">去代充</a>');
			}
		}).fail(function() {
			window.injs.showNetworkError();
		});
	}

	$("#quickStartupGame").html(html);
};

Entrance.showBought = function() {
	if (this.token) {
		$.ajax({
			type: "get",
			url: getUrl("order/bought"),
			jsonp: "callback",
			dataType: "jsonp",
			contentType: "text/html;charset=utf-8",
			cache: false,
			data: {
				version: this.client_version,
				token: this.token
			}
		}).done(function(data) {
			if (data.resultCode == 200) {
				Entrance.__showBought(data.orders);
			} else {
				Entrance.showDefaultBought();
			}
		}).fail(function() {
			Entrance.showDefaultBought();
			window.injs.showNetworkError();
		});
	} else {
		this.showLogin();
	}
};

Entrance.__showBought = function(map) {
	var is_empty = true;
	var html = '';
	var item;
	if (map.c2c_order) {
		item = map.c2c_order;
		html = '';
		html += '  <div class="left">';
		html += '    <img src="http://app.moyoyo.com/appstatic/game_icon/' + item.GAME_ID + '.png">';
		html += '  </div>';
		html += '  <div class="center">';
		html += item.NAME;
		html += '  </div>';
		html += '  <div class="right">';
		html += '    <p>游戏币</p>';
		html += '  </div>';
		$("#bought #c2c").attr("onclick", 'javascript:Module.goTo("http://m.moyoyo.com/gamezone/goods/list.html?gameid=' + item.GAME_ID + '&goodsid=0&sid=' + item.SERVER_ID + '&platformid=1");').html(
				html)
			.show();
		is_empty = false;
	} else {
		$("#bought #c2c").hide();
	}
	if (map.b2c_order) {
		item = map.b2c_order;
		html = '';
		html += '  <div class="left">';
		html += '    <img src="http://app.moyoyo.com/appstatic/game_icon/' + item.GAME_ID + '.png">';
		html += '  </div>';
		html += '  <div class="center">';
		channel = "通用";
		if (item.GOODS_TYPE_ID == 1) {
			if (/\[(.*)\]/.test(item.GOODS_NAME)) {
				channel = item.GOODS_NAME.match(/\[(.*)\]/)[1];
			}
			html += '【' + channel + '渠道】首充';
		} else {
			if (/(.*)代充/.test(item.NAME)) {
				channel = item.NAME.match(/(.*)代充/)[1];
			}
			price = 100;
			if (/(\d+)元/.test(item.NAME)) {
				price = item.NAME.match(/(\d+)元/)[1];
			}
			html += '【' + channel + '渠道】' + price + '元代充';
		}
		html += '  </div>';
		html += '  <div class="right">';
		html += '    <p>去代充</p>';
		html += '  </div>';
		$("#bought #b2c").attr("onclick", 'javascript:Module.goTo("http://m.moyoyo.com/gamezone/goods/list.html?gameid=' + item.GAME_ID + '&goodsid=0&sid=' + item.SERVER_ID + '&platformid=1");').html(
				html)
			.show();
		is_empty = false;
	} else {
		$("#bought #b2c").hide();
	}
	if (map.direct_charge_order) {
		item = map.direct_charge_order;
		html = '';
		html += '  <div class="left">';
		html += '    <img src="http://app.moyoyo.com/appstatic/h5/images/pic04.jpg">';
		html += '  </div>';
		html += '  <div class="center">';
		html += '    <p>' + item.AMOUNT + '元话费直充</p>';
		html += '    <p>' + item.CHARGE_NUM.substring(0, 3) + '*******' + item.CHARGE_NUM.substring(10, 11) + '</p>';
		html += '  </div>';
		html += '  <div class="right">';
		html += '    <a href="http://m.moyoyo.com/xhtml/pcs.jx?act=gopay&chargeNum=' + item.CHARGE_NUM + '&facePrice=' + item.AMOUNT + '&realPrice=' + item.REAL_PRICE + '">买买买</a>';
		html += '  </div>';
		$("#bought #direct_charge").html(html).show();
		is_empty = false;
	} else {
		$("#bought #direct_charge").hide();
	}
	if (map.charge_card_order) {
		item = map.charge_card_order;
		html = '';
		html += '  <div class="left">';
		html += '    <img src="http://app.moyoyo.com/appstatic/h5/images/pic01.jpg">';
		html += '  </div>';
		html += '  <div class="center">';
		html += '    <p>' + item.FACE_AMOUNT + '元' + (item.TYPE == 1 ? '充值卡' : 'Q币') + '</p>';
		html += '    <p>' + item.NAME + '</p>';
		html += '  </div>';
		html += '  <div class="right">';
		html += '    <a href="http://m.moyoyo.com/xhtml/pcs.jx?act=gopay&repositoryId=' + item.ID + '&providerName=' + item.NAME + '&facePrice=' + item.FACE_AMOUNT + '&realPrice=' + item.TEMP_PRICE /
			100 + '">买买买</a>';
		html += '  </div>';
		$("#bought #charge_card").html(html).show();
		is_empty = false;
	} else {
		$("#bought #charge_card").hide();
	}
	if (map.gift_order) {
		item = map.gift_order;
		html = '';
		html += '  <div class="left">';
		html += '    <img src="http://app.moyoyo.com/appstatic/h5/images/pic02.jpg">';
		html += '  </div>';
		html += '  <div class="center">' + item.NAME + '</div>';
		html += '  <div class="right">';
		html += '    <p>找礼包</p>';
		html += '  </div>';
		$("#bought #gift").attr("onclick", 'javascript:Module.goTo("http://m.moyoyo.com/codecard/list-3-1");').html(html).show();
		is_empty = false;
	} else {
		$("#bought #gift").hide();
	}
	if (map.apple_charge_order) {
		item = map.apple_charge_order;
		html = '';
		html += '  <div class="left">';
		html += '    <img src="http://app.moyoyo.com/appstatic/os_platform/black_apple_70x70.png">';
		html += '  </div>';
		html += '  <div class="center">';
		if (item.GAME_ID == 132) {
			html += item.SELLING_GOODS_PRICE / 100 + '元AppleID充值';
		} else {
			html += item.GAME_NAME + '' + item.SELLING_GOODS_PRICE + '元代充';
		}
		html += '  </div>';
		html += '  <div class="right">';
		if (item.GAME_ID == 132) {
			html += '    <a href="http://m.moyoyo.com/iosdeposit">买买买</a>';
		} else {
			html += '    <a href="http://m.moyoyo.com/gamezone/goods/list.html?gameid=' + item.GAME_ID + '&goodsid=' + item.GOODS_ID + '&platformid=3">买买买</a>';
		}
		html += '  </div>';
		$("#bought #apple").html(html).show();
		is_empty = false;
	} else {
		$("#bought #apple").hide();
	}
	if (is_empty) {
		this.showDefaultBought();
		return;
	} else {
		this.clearDefaultBought();
	}
};

Entrance.clearBought = function() {
	$("#bought #c2c").html("").hide();
	$("#bought #b2c").html("").hide();
	$("#bought #charge_card").html("").hide();
	$("#bought #direct_charge").html("").hide();
	$("#bought #gift").html("").hide();
	$("#bought #apple").html("").hide();
}

Entrance.clearDefaultBought = function() {
	$("#bought_default").html("").hide();
}

Entrance.showDefaultBought = function() {
	var html = '';
	html += '<div class="cntBox">';
	html += '  <div class="content-none">未曾购买任何商品</div>';
	html += '</div>';
	$("#bought_default").html(html).show();
	this.clearBought();
};

Entrance.showLogin = function() {
	this.clearBought();
	var html = '';
	html += '<div class="content-none">';
	html += '  您还没有登录，请您去<a href="http://m.moyoyo.com/member/index.html">登录</a>';
	html += '</div>';
	$("#bought_default").html(html).show();
};

function countCharacters(str) {
	var totalCount = 0;
	for (var i = 0; i < str.length; i++) {
		var c = str.charCodeAt(i);
		if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
			totalCount++;
		} else {
			totalCount += 2;
		}
	}
	return totalCount;
}

function get2Random(max) {
	var a = getRandom(max);
	var b = getRandom(max, a);
	return [a, b];
}

function getRandom(max, exist) {
	var a = Math.floor(Math.random() * max);
	if (a == exist) {
		return getRandom(max, exist);
	} else {
		return a;
	}
}

function getUrl(url) {
	return Entrance.base_uri + '/' + url;
}

var Module = {
	goTo: function(url, target) {
		var b = document.createElement("a");
		target || (target = "_self");
		b.click ? (b.setAttribute("href", url), b.setAttribute("target", target), b.style.display = "none", document.getElementsByTagName("body")[0].appendChild(b), b.click()) : "_self" ==
			target ? window.location.href = url : "_top" == target ? top.location.href =
			url : "_parent" == target ? parent.location.href = url : window.open(url);
	}
};
